package cn.iocoder.yudao.module.pms.framework.config;

import org.springframework.context.annotation.Bean;
import org.springframework.context.annotation.Configuration;
import org.springframework.scheduling.concurrent.ThreadPoolTaskExecutor;

import java.util.concurrent.ThreadPoolExecutor;

/**
 * 多线程配置
 */
@Configuration(proxyBeanMethods = false)
public class MultiThreadConfiguration {

    public static final String PMS_THREAD_POOL_TASK_EXECUTOR = "PMS_THREAD_POOL_TASK_EXECUTOR";

    @Bean(PMS_THREAD_POOL_TASK_EXECUTOR)
    public ThreadPoolTaskExecutor pmsThreadPoolTaskExecutor() {
        ThreadPoolTaskExecutor executor = new ThreadPoolTaskExecutor();
        executor.setCorePoolSize(8); // 设置核心线程数
        executor.setMaxPoolSize(16); // 设置最大线程数
        executor.setKeepAliveSeconds(60); // 设置空闲时间
        executor.setQueueCapacity(100); // 设置队列大小
        executor.setThreadNamePrefix("pms-task-"); // 配置线程池的前缀
        executor.setRejectedExecutionHandler(new ThreadPoolExecutor.CallerRunsPolicy());
        // 进行加载
        executor.initialize();
        return executor;
    }

}
